{ THIS FILE IS PART OF THE glPasGUI-PROJECT.

Copyright (c) 2009, Mag.Gertraude Trawnicek, Austria
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
      copyright notice, this list of conditions and the following
      disclaimer in the documentation and/or other materials provided
      with the distribution.
    * The name of the copyright holder must not be used to endorse
      or promote products derived from this software without specific
      prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES,INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}
//********************************************************************
// IMPLEMENTATION OSSupport (platform independent)
// Description: see unit OSSupport.pas
//********************************************************************
TYPE
   TButtonState = (bsNone, bsShift, bsControl, bsAlt);

   TPixelFormatInfo = Record
      ExtendedPixelFormat: TBool8;
      Multisampling: TBool8;
      MultiSamplePixelFormat: TuInt32;
   End;

VAR
   //*****************************************************************
   // Intern variables
   RenderContextInfo: TRenderContextInfo;
   PixelFormatInfo: TPixelFormatInfo;
   PreviousKey: TInt32;
   ButtonState: TButtonState;
   RootDir: TStringList;

Function  InternDisplayInitialize
               (IdentityString: TString8): TBool8; Forward;
Procedure InternDisplayFinalize; Forward;
//********************************************************************
// Initialization of platform independent variables
Function osDisplayInitialize(IdentityString: TString8;
                  ARenderContextInfo: TRenderContextInfo): TBool8;
Begin
   RenderContextInfo:= ARenderContextInfo;

   PreviousKey:= 0;
   ButtonState:= bsNone;

   With PixelFormatInfo Do Begin
      ExtendedPixelFormat:= FALSE;
      Multisampling:= FALSE;
   End;

   RootDir:= TStringList.Create;
   InternGetRootDir;

   Result:= InternDisplayInitialize(IdentityString);
End;
//********************************************************************
// Finalization of platform independent variables
Procedure osDisplayFinalize;
Begin
   RootDir.Free;
   InternDisplayFinalize;
End;
//********************************************************************
// Provide prepared Striglinst of RootDir
Function osRootDir: TStringList;
Begin
   Result:= RootDir;
End;
//********************************************************************

