{ THIS FILE IS PART OF THE glPasGUI-PROJECT.

Copyright (c) 2009, Mag.Gertraude Trawnicek, Austria
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
      copyright notice, this list of conditions and the following
      disclaimer in the documentation and/or other materials provided
      with the distribution.
    * The name of the copyright holder must not be used to endorse
      or promote products derived from this software without specific
      prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES,INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}
//********************************************************************
// IMPLEMENTATION OSSupportWin32
// Description: see unit OSSupport.pas
//********************************************************************
USES
   Windows,Messages,MMSystem;

VAR
   WindowClassName: TString8; // Unicode-Switch &&&&&
   HWFrequency: TInt64;
   IAttrib: Array[0..20] Of TuInt32;


Procedure InternGetRootDir; Forward;
Function InternEventReceive(AWindow,AMessage: TuInt32;
                   WParam,LParam: TInt32): TInt32; StdCall; Forward;
Function InternTranslateKey(AKey: TInt32): TInt32; Forward;
//********************************************************************
// I N I T I A L I Z E  /  F I N A L I Z E
//********************************************************************
{$I OSSupport.inc}
//********************************************************************
Function InternDisplayInitialize(IdentityString: TString8): TBool8;
Var                                    // Unicode-Switch &&&&&
   // Unicode-Switch &&&&&
   WindowClass: TWndClassExA;
   //WindowClass: TWndClassExW;
Begin
   WindowClassName:= IdentityString;

   With WindowClass Do Begin
      cbSize:= SizeOf(WindowClass);
      Style:= CS_OWNDC;
      lpfnWndProc:= @InternEventReceive;
      cbClsExtra:= 0;
      cbWndExtra:= 0;
      hInstance:= System.MainInstance;
      hIcon:= LoadIcon(0, idi_Application);
      hCursor:= LoadCursor(0, idc_Arrow);
      hbrBackground:= GetStockObject(HOLLOW_BRUSH);
      lpszMenuName:= NIL;
      // Unicode-Switch &&&&&
      lpszClassName:= PChar(WindowClassName);
      //lpszClassName:= PWideChar(WindowClassName);
      hIconSm:= LoadIcon(0, idi_Application);
   End;

   // Unicode-Switch &&&&&
   Result:= RegisterClassExA(WindowClass) <> 0;
   //Result:= RegisterClassExW(WindowClass) <> 0;

   HWFrequency:= osClockFrequency;
End;
//********************************************************************
Procedure InternDisplayFinalize;
Begin

   // Unicode-Switch &&&&&
   UnregisterClassA(PChar(WindowClassName),System.MainInstance);
   //UnregisterClassW(PWideChar(WindowClassName),System.MainInstance);
End;
//********************************************************************
Function osDisplay: TPoint32;
Begin
   Result:= NIL;
End;
//********************************************************************
//   C L O C K
//********************************************************************
Function osClockFrequency: TInt64;
Begin
   If Not QueryPerformanceFrequency(Result)
      Then Raise OSException.Create('No hardware timer found');
End;
//********************************************************************
Function osClockTick: TInt64;
Var Temp: TInt64;
Begin
   QueryPerformanceCounter(Temp);
   Result:= Temp*1000 Div HWFrequency;
End;
//********************************************************************
//   C O P Y  &  P A S T E
//********************************************************************
Procedure osCopyString(AWindow: TuInt32; AString: TString8); // Unicode-Switch &&&&&
Var
  StringHandle: TuInt32;
  StringSize: TuInt32;
  StringPtr: PChar8;
Begin
   If OpenClipBoard(AWindow) Then Begin
      StringSize:= Length(AString) * 2 + 2;  // Unicode-Switch &&&&&
      Try
         StringHandle:= GlobalAlloc(GMEM_FIXED, StringSize);
         //StringHandle:=  GlobalAlloc(GMEM_MOVEABLE+GMEM_DDESHARE, StrSize);
         Try
            StringPtr:= GlobalLock(StringHandle);
            FillChar(StringPtr^,StringSize,#0);
            Try
               Move(AString[1], StringPtr^, StringSize);
               EmptyClipBoard;
               SetClipBoardData(CF_UNICODETEXT,StringHandle);
            Finally
               GlobalUnlock(StringHandle);
            End;
         Except
            GlobalFree(StringHandle);
            Raise;
         End;
      Finally
         CloseClipBoard;
      End;
   End;                                  
End;
//********************************************************************
Function osPasteString(AWindow: TuInt32): TString8; // Unicode-Switch &&&&&
Var
  StringHandle: TuInt32;
  // Unicode-Switch &&&&&
  //StringPtr: PChar16;
  StringPtr: PChar8;
Begin
   Result:= '';

   If OpenClipBoard(AWindow) Then Begin
      StringHandle:= GetClipBoardData(CF_UNICODETEXT); // Unicode-Switch &&&&&
      If StringHandle <> 0
         Then Begin
           StringPtr:= GlobalLock(StringHandle);
           // Unicode-Switch &&&&&
           Result:= TString8(StringPtr);
           GlobalUnlock(StringHandle);
         End;
      CloseClipBoard;
   End;
End;
//********************************************************************
//   D I R E C T O R I E S
//********************************************************************
// Function osRootDir: see OSSupport.Inc
//********************************************************************
{Function osGetDriveType(ADriveName: T8bString): TDriveType;
Var osDriveType: TuInt32;
Begin
   // Unicode-Switch &&&&&
   osDriveType:= GetDriveTypeA(PAnsiChar(ADriveName));
   //osDriveType:= GetDriveTypeW(PWideChar(ADriveName));
   Result:= TDriveType(osDriveType);
End; }
//********************************************************************
//   E V E N T S
//********************************************************************
Function osEventProcess(AWindow: TuInt32;
               WaitForMessage: TBool8): TBool8;
Var
   Msg: TMsg; GotMessage: TBool8;
Begin
   Result:= FALSE;

   If WaitForMessage
      Then GotMessage:= GetMessageA(Msg,0,0,0)
      Else GotMessage:= PeekMessageA(Msg,0,0,0,PM_REMOVE);

   If GotMessage Then Begin
      TranslateMessage(Msg);
      DispatchMessageA(Msg);
      Result:= TRUE;
   End; 

   // Unicode-Switch &&&&&
   {If WaitForMessage
      Then GotMessage:= GetMessageW(Msg, 0, 0, 0)
      Else GotMessage:= PeekMessageW(Msg, 0, 0, 0, PM_REMOVE);

   If GotMessage Then Begin
      TranslateMessage(Msg);
      DispatchMessageW(Msg);
      Result:= TRUE;
   End; }
End;
//********************************************************************
Procedure osEventTerminateApplication;
Begin
   PostQuitMessage(0);
End;
//********************************************************************
//   M O U S E
//********************************************************************
Procedure osMouseCapture(AWindow: TuInt32);
Begin
   SetCapture(AWindow);
End;
//********************************************************************
Procedure osMouseCaptureRelease;
Begin
   ReleaseCapture;
End;
//********************************************************************
Procedure osMouseImageSet(AWindow: TuInt32; AMouseImage: TMouseImage);
Var
   MouseCursor: hCursor;
Begin
   MouseCursor:= LoadCursor(0,idc_Arrow);
   Case AMouseImage Of
      miHourGlass : MouseCursor:= LoadCursor(0,idc_Wait);
      miIBeam     : MouseCursor:= LoadCursor(0,idc_IBeam);
      miMoving    : MouseCursor:= LoadCursor(0,idc_SizeAll);
      miSizing    : MouseCursor:= LoadCursor(0,idc_SizeNWSE);
      miCross     : MouseCursor:= LoadCursor(0,idc_Cross);
   End;
   SetCursor(MouseCursor);
   // Unicode-Switch &&&&&
   //SetClassLongW(AWindow, gcl_hCursor, MouseCursor);
End;
//********************************************************************
Function osMousePosition(AWindow: TuInt32): TPoint2D;
Begin
   FillChar(Result,SizeOf(Result),#0);
End;
//********************************************************************
Procedure osMousePositionSet(AWindow: TuInt32; AX,AY: TInt32);
Var LPoint: TPoint;
Begin
   With LPoint Do Begin X:= AX; Y:= AY; End;
   ClientToScreen(AWindow,LPoint);
End;
//********************************************************************
//   R E N D E R I N G   C O N T E X T
//********************************************************************
Procedure osFill_IAttrib;
Begin
   IAttrib [0]:= WGL_DRAW_TO_WINDOW_ARB;
   IAttrib [1]:= 1;

   IAttrib [2]:= WGL_SUPPORT_OPENGL_ARB;
   IAttrib [3]:= 1;

   IAttrib [4]:= WGL_DOUBLE_BUFFER_ARB;
   IAttrib [5]:= 1;

   IAttrib [6]:= WGL_PIXEL_TYPE_ARB;
   IAttrib [7]:= WGL_TYPE_RGBA_ARB;

   IAttrib [8]:= WGL_COLOR_BITS_ARB;
   IAttrib [9]:= 24;

   IAttrib[10]:= WGL_ALPHA_BITS_ARB;
   IAttrib[11]:= 8;

   IAttrib[12]:= WGL_DEPTH_BITS_ARB;
   IAttrib[13]:= 24;

   IAttrib[14]:= WGL_STENCIL_BITS_ARB;
   IAttrib[15]:= 0;

   IAttrib[16]:= WGL_SAMPLE_BUFFERS_ARB;
   IAttrib[17]:= 1;

   IAttrib[18]:= WGL_SAMPLES_ARB;
   IAttrib[19]:= 6;

   IAttrib[20]:= 0;
End;
//********************************************************************
Procedure osGetPixelFormatInfo;
Var
   TempWindow,TempDC,TempRC: TuInt32;
   FAttrib: TFloat32;
   PixelFormat: Array[0..63] of TuInt32;
   NumPixelFormats: TuInt32;
   ARBPointer: TPoint32;

Begin
   // Create window + context (GraphicLib is already initialized)
   TempWindow:= osWindowCreate(wtPopup,'',0,0,10,10);
   TempDC:= GetDC(TempWindow);
   TempRC:= CreateRenderingContext
      (TempDC,[opDoubleBuffered],24,24,0,0,0,0);
   ActivateRenderingContext(TempDC,TempRC);

   Read_WGL_ARB_Pixel_Format; // because ReadExtensions is not yet called
   ARBPointer:= @wglChoosePixelFormatARB;

   If ARBPointer <> NIL Then Begin

      PixelFormatInfo.ExtendedPixelFormat:= TRUE; // Update PixelFormatInfo

      osFill_IAttrib;
      FAttrib:= 0;

      wglChoosePixelFormatARB(TempDC,@IAttrib,@FAttrib,
           Length(PixelFormat),@PixelFormat,@NumPixelFormats);

      // Update PixelFormatInfo
      If NumPixelFormats > 0 Then With PixelFormatInfo Do Begin
         Multisampling:= TRUE;
         MultiSamplePixelFormat:= PixelFormat[0];
      End;
   End;

   // Destroy temporary context and temporary window
   DestroyRenderingContext(TempRC);
   ReleaseDC(TempWindow, TempDC);
   osWindowDestroy(TempWindow);
End;
//********************************************************************
Function osRC_CreateExtended(AWindow: TuInt32): TuInt32;
Var
   DC,RC: TuInt32;
   PixelFormatRec: TPixelFormatDescriptor;
   PixelFormat: TInt32;
Begin
   Result:= 0;

   FillChar(PixelFormat, SizeOf(PixelFormat), 0);

   With PixelFormatRec Do Begin
      nSize       := SizeOf(PixelFormatRec);
      nVersion    := 1;
      dwFlags     := PFD_SUPPORT_OPENGL;
      dwFlags     := dwFlags OR PFD_DRAW_TO_WINDOW;
      dwFlags     := dwFlags OR PFD_DOUBLEBUFFER;
      iPixelType  := PFD_TYPE_RGBA;
      cColorBits  := 32;
      cDepthBits  := 24;
      cStencilBits:= 0;
      cAccumBits  := 0;
      cAuxBuffers := 0;
      iLayerType  := 0;
   End;

   DC:= GetDC(AWindow);

   PixelFormat:= PixelFormatInfo.MultiSamplePixelFormat;

   If PixelFormat <> 0
      Then Begin
         SetPixelFormat(DC,PixelFormat,@PixelFormatRec);
         DescribePixelFormat(DC,PixelFormat,
                       SizeOf(PixelFormatRec),PixelFormatRec);
         RC:= wglCreateContext(DC);

         If (DC <> 0) And (RC <> 0) Then Begin
            wglMakeCurrent(DC,RC);
            Result:= RC;
         End;
      End;
End;
//********************************************************************
Function osRenderContextCreate
               (AWindow,ASharedContext: TuInt32): TuInt32;
Var
   DevContext,LocalContext: TuInt32;
   LocalRCOptions: TRCOptions;
Begin
   With RenderContextInfo Do Begin
      LocalRCOptions:= [];
      If IsDoubleBuffered
         Then LocalRCOptions:= LocalRCOptions+[opDoubleBuffered];
      If IsStereo
         Then LocalRCOptions:= LocalRCOptions+[opStereo];
   End;

   {If ASharedContext <> 0
      Then osGetPixelFormatInfo; }

   DevContext:= GetDC(AWindow);

   {If PixelFormatInfo.Multisampling
      Then LocalContext:= osRC_CreateExtended(AWindow)
      Else LocalContext:= CreateRenderingContext
          (DevContext,[opDoubleBuffered],32,24,0,0,0,0); }

   With RenderContextInfo Do
      LocalContext:= CreateRenderingContext
          (DevContext,LocalRCOptions,
           ColorBits, ZBits, StencilBits,
           AccumBits, AuxBuffers,Level);
   ActivateRenderingContext(DevContext,LocalContext);

   If ASharedContext <> 0
      Then wglShareLists(ASharedContext,LocalContext);

   Result:= LocalContext;
End;
//********************************************************************
Function osRenderContextDestroy
               (AWindow,ARenderContext: TuInt32): TBool8;
Begin
   Result:= FALSE;

   If osRenderContextActivate(AWindow,ARenderContext)
      Then Begin
         wglDeleteContext(ARenderContext);
         Result:= TRUE;
      End;
End;
//********************************************************************
Function osRenderContextActivate
               (AWindow,ARenderContext: TuInt32): TBool8;
Var DeviceContext: TuInt32;
Begin
   Result:= FALSE;

   DeviceContext:= GetDC(AWindow);

   If (DeviceContext <> 0) And (ARenderContext <> 0)
      Then Begin
         wglMakeCurrent(DeviceContext,ARenderContext);
         Result:= TRUE;
      End;
End;
//********************************************************************
Procedure osRenderContextDeactivate;
Begin
  wglMakeCurrent(0,0);
End;
//********************************************************************
Function osGetCurrentContext: TuInt32;
Begin
  Result:= TuInt32(wglGetCurrentContext);
End;
//********************************************************************
//   V I D E O M O D E
//********************************************************************
Function osVideoSettings: TVideoSettings;
Var DC: TuInt32;
Begin
   DC:= GetDC(0);

   FillChar(Result, SizeOf(TVideoSettings), #0);
   If DC <> 0 Then With Result Do Begin
      BitsPerPixel:= GetDeviceCaps(DC, BITSPIXEL);
      Frequency   := GetDeviceCaps(DC, VREFRESH);
      Width       := GetDeviceCaps(DC, HORZRES);
      Height      := GetDeviceCaps(DC, VERTRES);
   End;
End;
//********************************************************************
//   W I N D O W S
//********************************************************************
Function osWindowCreate(AWindowType: TWindowType;
               ACaption: TString8; // Unicode-Switch &&&&&
               ALeft,ATop,AWidth,AHeight: TInt32): TuInt32;
Const
   ParentWindow = 0;
   MainMenu = 0;
Var
   WinStyle, ExStyle: TuInt32;
Begin
   ExStyle:= WS_EX_LEFT;

   // WS_EX_TRANSPARENT is only for showing through windows created
   // by the same thread.
   //ExStyle:= WS_EX_TRANSPARENT;                // See-through
   //ExStyle:= WS_EX_LAYERED Or WS_EX_TOPMOST;   // Click-through

   // &&&&& Attention! Incompatibility of WS_POPUP in FPC
   // WS_POPUP is defined as "LONG" in FPC but has to be a Cardinal
   // WinStyle:= TuInt32($80000000); // WS_POPUP

   Case AWindowType Of
           wtPopup,
        wtStandard: WinStyle:= WS_POPUP;
        //wtNative: WinStyle:= WS_OverlappedWindow;
      wtFullScreen: WinStyle:= WS_EX_TOPMOST Or WS_POPUP;
   End; // Of Case

   Result:= CreateWindowExA
           (ExStyle,
            PChar(WindowClassName),
            PChar(ACaption),
            WinStyle,
            ALeft,ATop,AWidth,AHeight,
            ParentWindow, MainMenu, System.MainInstance, NIL);

   // Unicode-Switch &&&&&
   {Result:= CreateWindowExW
           (ExStyle,
            PWideChar(WindowClassName),
            PWideChar(ACaption),
            WinStyle,
            ALeft,ATop,AWidth,AHeight,
            ParentWindow, MainMenu, System.MainInstance, NIL); }
End;
//********************************************************************
Procedure osWindowDestroy(AWindow: TuInt32);
Begin
   DestroyWindow(AWindow);
End;
//********************************************************************
Procedure osWindowCaption(AWindow: TuInt32; ACaption: TString8);
Begin
   // Unicode-Switch &&&&&
   SetWindowText(AWindow,PChar(ACaption));
   //SetWindowTextW(AWindow,PWideChar(ACaption));
End;
//********************************************************************
Procedure osWindowDisplay(AWindow: TuInt32; Visible: TBool8);
Begin
   If Visible
      Then ShowWindow(AWindow,SW_SHOW)
      Else ShowWindow(AWindow,SW_HIDE);
End;
//********************************************************************
Procedure osWindowMaximize(AWindow: TuInt32);
Begin
   ShowWindow(AWindow,SW_MAXIMIZE);
End;
//********************************************************************
Procedure osWindowMinimize(AWindow: TuInt32);
Begin
   ShowWindow(AWindow,SW_MINIMIZE);
End;
//********************************************************************
Procedure osWindowMove(AWindow: TuInt32; ALeft,ATop: TInt32);
Begin
   SetWindowPos(AWindow,HWND_TOP,ALeft,ATop,0,0,SWP_NOSIZE);
End;
//********************************************************************
Procedure osWindowResize(AWindow: TuInt32; AWidth,AHeight: TInt32);
Begin
   SetWindowPos(AWindow,HWND_TOP,0,0,AWidth,AHeight,SWP_NOMOVE);
End;
//********************************************************************
// As we have to simulate the maximized window state because WS_POPUP
// cannot be maximized, the procedure SHOWWINDOW does not work here,
// because the window thinks to be in "normal" state.
Procedure osWindowRestore(AWindow: TuInt32;
               ALeft,ATop,AWidth,AHeight: TInt32);
Begin
   //ShowWindow(AWindow,SW_RESTORE);
   SetWindowPos(AWindow,HWND_TOP,ALeft,ATop,AWidth,AHeight,SWP_SHOWWINDOW);
End;
//********************************************************************
Procedure osWindowSwapBuffers(AWindow: TuInt32);
Begin
   SwapBuffers(GetDC(AWindow));
End;
//********************************************************************
// "S P E C I A L" - Windows routines (for MS-Windows only)
//********************************************************************
Procedure osWindowSpecialMove(AWindow: TuInt32; MouseX,MouseY: TInt32);
Begin
   osMouseCaptureRelease;
   //osMouseImageSet(AWindow,miMoving,MouseX,MouseY);

   // Unicode-Switch &&&&&
   SendMessageA(AWindow,WM_SYSCOMMAND,SC_MOVE Or HTCAPTION,0);
   //SendMessageW(AWindow,WM_SYSCOMMAND,SC_MOVE Or HTCAPTION,0);
End;
//********************************************************************
Procedure osWindowSpecialResize(AWindow: TuInt32; MouseX,MouseY: TInt32);
Begin
   osMouseCaptureRelease;
   //osMouseImageSet(AWindow,miSizing,MouseX,MouseY);

   // Unicode-Switch &&&&&
   SendMessageA(AWindow,WM_SYSCOMMAND,SC_SIZE Or WMSZ_BOTTOMRIGHT, 0);
   //SendMessageW(AWindow,WM_SYSCOMMAND,SC_SIZE Or WMSZ_BOTTOMRIGHT, 0);
End;
//********************************************************************
//   I N T E R N   R O U T I N E S
//********************************************************************
// The DriveStrings include a final backslash
Procedure InternGetRootDir;
Var
   StrgLen: TuInt32;
   AllStrings, CurString: PChar;
   Done: TBool8;
Begin
   StrgLen := 255;
   GetMem(AllStrings, StrgLen+1);
   GetLogicalDriveStrings(StrgLen, AllStrings);

   If AllStrings <> NIL Then Begin
      CurString:= AllStrings;
      Done:= FALSE;

      While Not Done Do Begin
        RootDir.Add(StrPas(CurString));
        Inc(CurString, Succ(StrLen(CurString)));
        If CurString[0] = #0
           Then Done:= TRUE;
      End;
   End;
End;
//********************************************************************
Function InternEventReceive(AWindow,AMessage: TuInt32;
                   WParam,LParam: TInt32): TInt32; StdCall;
Var
   Longint1,Longint2,Longint3: TInt32;
   Rect: TRect;
Begin
   With EventPipeline Do Case AMessage Of

      WM_CLOSE: Begin
         If Assigned(OnClose)
            Then OnClose(AWindow);
         Result:= TInt32(TRUE);
      End;

      WM_NCACTIVATE : If IsIconic(AWindow) Then Begin
         If Assigned(OnRestore)
            Then OnRestore(AWindow);
         Result:= TInt32(TRUE);
      End;

      WM_PAINT: Begin
         If Assigned(OnPaint)
            Then OnPaint(AWindow);
         // This stops the WM_PAINT-loop
         GetUpdateRect(AWindow,Rect,TRUE);
         ValidateRect(AWindow,@Rect);
         Result:= TInt32(TRUE);
      End;

      {WM_MOVE: Begin
         If Assigned(OnMove) Then Begin
            GetWindowRect(AWindow,Rect);
            With Rect Do Begin
               Longint1:= Right-Left;
               Longint2:= Bottom-Top;
            End;
            OnMove(AWindow,Longint1,Longint2);
         End;
         Result:= TInt32(TRUE);
      End; }

      WM_SIZE: Begin
         If Assigned(OnResize) Then Begin
            GetWindowRect(AWindow,Rect);
            With Rect Do Begin
               Longint1:= Right-Left;
               Longint2:= Bottom-Top;
            End;
            OnResize(AWindow,Longint1,Longint2);
         End;
         Result:= TInt32(TRUE);
      End;

      WM_SETCURSOR: Begin
         Result:= TInt32(TRUE);
      End;

      WM_KEYDOWN: Begin  // Function keys only!
         If Assigned(OnKeyDown) Then Begin
            WParam:= InternTranslateKey(WParam);
            OnKeyDown(AWindow, WParam, PreviousKey);
            PreviousKey:= WParam;
         End;
         Result:= TInt32(TRUE);
      End;

      WM_KEYUP: Begin // Function keys only!
         If Assigned(OnKeyUp) Then Begin
            WParam:= InternTranslateKey(WParam);
            OnKeyUp(AWindow, WParam, PreviousKey);
         End;
         Result:= TInt32(TRUE);
      End;

      WM_CHAR: Begin
         If Assigned(OnKeyDown) Then Begin
            OnKeyDown(AWindow, WParam, PreviousKey);
         End;
         Result:= TInt32(TRUE);
      End;

      WM_LBUTTONDOWN: Begin
         If Assigned(OnMouseBtnLDown) Then Begin
            Longint1:= TuInt32Rec(LParam).Low;
            Longint2:= TuInt32Rec(LParam).High;
            If WParam = WParam Or MK_CONTROL
               Then WParam:= FK_CONTROL;
            OnMouseBtnLDown(AWindow, Longint1,Longint2,WParam);
         End;
         Result:= TInt32(TRUE);
      End;

      WM_LBUTTONUP: Begin
         If Assigned(OnMouseBtnLUp) Then Begin
            Longint1:= TuInt32Rec(LParam).Low;
            Longint2:= TuInt32Rec(LParam).High;
            OnMouseBtnLUp(AWindow, Longint1,Longint2,WParam);
         End;
         Result:= TInt32(TRUE);
      End;

      WM_RBUTTONDOWN: Begin
         If Assigned(OnMouseBtnRDown) Then Begin
            Longint1:= TuInt32Rec(LParam).Low;
            Longint2:= TuInt32Rec(LParam).High;
            OnMouseBtnRDown(AWindow, Longint1,Longint2,WParam);
         End;
         Result:= TInt32(TRUE);
      End;

      WM_MBUTTONDOWN: Begin
         If Assigned(OnMouseBtnMDown) Then Begin
            Longint1:= TuInt32Rec(LParam).Low;
            Longint2:= TuInt32Rec(LParam).High;
            OnMouseBtnMDown(AWindow, Longint1,Longint2,WParam);
         End;
         Result:= TInt32(TRUE);
      End;

      WM_MOUSEMOVE: Begin
         If Assigned(OnMouseMove) Then Begin
            Longint1:= TuInt32Rec(LParam).Low;
            Longint2:= TuInt32Rec(LParam).High;
            OnMouseMove(AWindow, Longint1,Longint2);
         End;
         Result:= TInt32(TRUE);
      End;

      WM_MOUSEWHEEL: Begin
         LongInt3:= TuInt32Rec(WParam).High;
         If LongInt3 > 0
            Then Begin
               If Assigned(OnMouseWheelUp) Then Begin
                  Longint1:= TuInt32Rec(LParam).Low;
                  Longint2:= TuInt32Rec(LParam).High;
                  OnMouseWheelUp
                     (AWindow, Longint1,Longint2,Longint3);
               End;
            End
            Else Begin
               If Assigned(OnMouseWheelDown) Then Begin
                  Longint1:= TuInt32Rec(LParam).Low;
                  Longint2:= TuInt32Rec(LParam).High;
                  OnMouseWheelDown(AWindow,
                     Longint1,Longint2,Longint3);
               End;
            End;
         Result:= TInt32(TRUE);
      End;

      Else 
         // Unicode-Switch &&&&&
         Result:= DefWindowProcA(AWindow,AMessage,WParam,LParam);
         //Result:= DefWindowProcW(AWindow,AMessage,WParam,LParam);

   End; // Of Case
End;
//********************************************************************
Function InternTranslateKey(AKey: TInt32): TInt32;
Begin
   Case AKey Of

      VK_BACK: Result:= FK_BACK;            // VK_BACK = 8;
      VK_TAB: Result:= FK_TAB;              // VK_TAB = 9;
      VK_CLEAR: Result:= FK_CLEAR;          // VK_CLEAR = 12;
      VK_RETURN: Result:= FK_RETURN;        // VK_RETURN = 13;
      VK_SHIFT: Result:= FK_SHIFT;          // VK_SHIFT = $10;
      VK_CONTROL: Result:= FK_CONTROL;      // VK_CONTROL = 17;
      VK_MENU: Result:= FK_ALT;             // VK_MENU = 18;
      VK_PAUSE: Result:= FK_PAUSE;          // VK_PAUSE = 19;
      VK_CAPITAL: Result:= FK_CAPITAL;      // VK_CAPITAL = 20;
      VK_ESCAPE: Result:= FK_ESCAPE;        // VK_ESCAPE = 27;
      VK_SPACE: Result:= FK_SPACE;          // VK_SPACE = $20;
      VK_PRIOR: Result:= FK_PRIOR;          // VK_PRIOR = 33;
      VK_NEXT: Result:= FK_NEXT;            // VK_NEXT = 34;
      VK_END: Result:= FK_END;              // VK_END = 35;
      VK_HOME: Result:= FK_HOME;            // VK_HOME = 36;
      VK_LEFT: Result:= FK_LEFT;            // VK_LEFT = 37;
      VK_UP: Result:= FK_UP;                // VK_UP = 38;
      VK_RIGHT: Result:= FK_RIGHT;          // VK_RIGHT = 39;
      VK_DOWN: Result:= FK_DOWN;            // VK_DOWN = 40;
      VK_INSERT: Result:= FK_INSERT;        // VK_INSERT = 45;
      VK_DELETE: Result:= FK_DELETE;        // VK_DELETE = 46;
      VK_NUMPAD0: Result:= FK_NUMPAD0;      // VK_NUMPAD0 = 96;
      VK_NUMPAD1: Result:= FK_NUMPAD1;      // VK_NUMPAD1 = 97;
      VK_NUMPAD2: Result:= FK_NUMPAD2;      // VK_NUMPAD2 = 98;
      VK_NUMPAD3: Result:= FK_NUMPAD3;      // VK_NUMPAD3 = 99;
      VK_NUMPAD4: Result:= FK_NUMPAD4;      // VK_NUMPAD4 = 100;
      VK_NUMPAD5: Result:= FK_NUMPAD5;      // VK_NUMPAD5 = 101;
      VK_NUMPAD6: Result:= FK_NUMPAD6;      // VK_NUMPAD6 = 102;
      VK_NUMPAD7: Result:= FK_NUMPAD7;      // VK_NUMPAD7 = 103;
      VK_NUMPAD8: Result:= FK_NUMPAD8;      // VK_NUMPAD8 = 104;
      VK_NUMPAD9: Result:= FK_NUMPAD9;      // VK_NUMPAD9 = 105;
      VK_MULTIPLY: Result:= FK_MULTIPLY;    // VK_MULTIPLY = 106;
      VK_ADD: Result:= FK_ADD;              // VK_ADD = 107;
      VK_SEPARATOR: Result:= FK_SEPARATOR;  // VK_SEPARATOR = 108;
      VK_SUBTRACT: Result:= FK_SUBTRACT;    // VK_SUBTRACT = 109;
      VK_DECIMAL: Result:= FK_DECIMAL;      // VK_DECIMAL = 110;
      VK_DIVIDE: Result:= FK_DIVIDE;        // VK_DIVIDE = 111;
      VK_F1: Result:= FK_F1;                // VK_F1 = 112;
      VK_F2: Result:= FK_F2;                // VK_F2 = 113;
      VK_F3: Result:= FK_F3;                // VK_F3 = 114;
      VK_F4: Result:= FK_F4;                // VK_F4 = 115;
      VK_F5: Result:= FK_F5;                // VK_F5 = 116;
      VK_F6: Result:= FK_F6;                // VK_F6 = 117;
      VK_F7: Result:= FK_F7;                // VK_F7 = 118;
      VK_F8: Result:= FK_F8;                // VK_F8 = 119;
      VK_F9: Result:= FK_F9;                // VK_F9 = 120;
      VK_F10: Result:= FK_F10;              // VK_F10 = 121;
      VK_F11: Result:= FK_F11;              // VK_F11 = 122;
      VK_F12: Result:= FK_F12;              // VK_F12 = 123;
      VK_NUMLOCK: Result:= FK_NUMLOCK;      // VK_NUMLOCK = 144;
      VK_SCROLL: Result:= FK_SCROLL;        // VK_SCROLL = 145;

      Ord('Z'): If PreviousKey = FK_CONTROL
         Then Result:= FK_UNDO
         //Else Result:= AKey; // Don't send a 'Z' to the user 
         Else Result:= 0;      // if it's meant as a function key

      Else Result:= 0;

   End; //Of Case
End;
//********************************************************************

