{ THIS FILE IS PART OF THE glPasGUI-PROJECT.

Copyright (c) 2009, Mag.Gertraude Trawnicek, Austria
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
      copyright notice, this list of conditions and the following
      disclaimer in the documentation and/or other materials provided
      with the distribution.
    * The name of the copyright holder must not be used to endorse
      or promote products derived from this software without specific
      prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES,INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}
//********************************************************************
// IMPLEMENTATION OSSupportX11
// Description: see unit OSSupport.pas
//********************************************************************
USES
   LibC, Unix, X, XLib, XUtil, XAtom, XRandr, KeySym, CursorFont,
   glxTEST;

CONST
   _NET_SOURCE_APPLICATION = 1;
   _NET_SOURCE_PAGER       = 2;

   _NET_WM_STATE_REMOVE    = 0;    // remove/unset property
   _NET_WM_STATE_ADD       = 1;    // add/set property
   _NET_WM_STATE_TOGGLE    = 2;    // toggle property

   //MWM_HINTS_FUNC     = 1 Shl 0;
   MWM_HINTS_DECO     = 1 Shl 1;
   {MWM_HINTS_INPUT    = 1 Shl 2;
   MWM_HINTS_STATUS   = 1 Shl 3;

   MWM_FUNC_ALL       = 1 Shl 0;
   MWM_FUNC_RESIZE    = 1 Shl 1;
   MWM_FUNC_MOVE      = 1 Shl 2;
   MWM_FUNC_MINIMIZE  = 1 Shl 3;
   MWM_FUNC_MAXIMIZE  = 1 Shl 4;
   MWM_FUNC_CLOSE     = 1 Shl 5;

   MWM_DECOR_ALL      = 1 Shl 0;
   MWM_DECOR_BORDER   = 1 Shl 1;
   MWM_DECOR_RESIZEH  = 1 Shl 2;
   MWM_DECOR_TITLE    = 1 Shl 3;
   MWM_DECOR_MENU     = 1 Shl 4;
   MWM_DECOR_MINIMIZE = 1 Shl 5;
   MWM_DECOR_MAXIMIZE = 1 Shl 6; }

   {MWM_INPUT_MODELESS = 0;
   MWM_INPUT_PRIMARY_APPLICATION_MODAL = 1;
   MWM_INPUT_SYSTEM_MODAL = 2;
   MWM_INPUT_FULL_APPLICATION_MODAL = 3;
   MWM_INPUT_APPLICATION_MODAL = MWM_INPUT_PRIMARY_APPLICATION_MODAL; }

VAR
   XDisplay: TPoint32;

   // ATOMS (=TuInt32) ----
   XA_ATOM,
   XA_CLIPBOARD,
   XA_TARGETS,
   XA_STRING,
   XA_TEXT,
   XA_COMPOUND_TEXT,
   XA_UTF8_STRING,
   XA_DATA_ATOM,

   MOTIF_WM_HINTS,
   WM_HINTS,
   NET_WM_WINDOW_TYPE,
   NET_WM_WINDOW_TYPE_NORMAL,
   NET_WM_STATE_MAXIMIZED_HORZ,
   NET_WM_STATE_MAXIMIZED_VERT,
   NET_WM_STATE_FULLSCREEN,
   NET_WM_STATE         : TAtom;


   XVisualProperties: PXVisualInfo;
   XClipBoard: TString8;

Procedure InternGetRootDir; Forward;
Procedure InternEventReceive(AWindow: TuInt32; AXEvent: TXEvent); Forward;
Procedure InternSetAtoms; Forward;
Procedure InternStateChange(AWindow: TuInt32; State1,State2: TAtom); Forward;
Function  InternTranslateKey(AKey: TuInt32): TInt32; Forward;
//********************************************************************
{$I OSSupport.inc}  // platform independent part
//********************************************************************
// I N I T I A L I Z E  /  F I N A L I Z E
//********************************************************************
Function InternDisplayInitialize(IdentityString: TString8): TBool8;
Const XAttribSize = 30;
Var
   ErrorBase, EventBase: TInt32;
   XAttrib: Array[0..XAttribSize-1] Of TInt32;
   Temp: TInt32;
   Index, Dividend: TuInt8;

Procedure FillXAttrib(ADescription, AValue: TInt32);
Begin
   If Index < XAttribSize
      Then Begin
         XAttrib[Index]:= ADescription;
         Inc(Index);
      End;
   If (Index < XAttribSize) And (AValue >= 0)
      Then Begin
         XAttrib[Index]:= AValue;
         Inc(Index);
      End;
End;

Begin
   Result:= FALSE;

   // Connect to XServer
   XDisplay:= XOpenDisplay(NIL);
   If XDisplay <> NIL Then Begin

      // Check GLX Extension
      InitGLX(); // Get GLX routines

      If (glxQueryExtension(XDisplay,ErrorBase,EventBase))
         Then Result:= TRUE
         Else Result:= FALSE;

      // Specifies the visual properties
      Index:= 0;
      FillChar(XAttrib,SizeOf(XAttrib),#0);

      With RenderContextInfo Do Begin
         If IsRGBA Then FillXAttrib(GLX_RGBA,-1);
         If IsDoubleBuffered Then FillXAttrib(GLX_DOUBLEBUFFER,-1);
         If IsStereo Then FillXAttrib(GLX_STEREO,-1);
         FillXAttrib(GLX_BUFFER_SIZE,ColorBits);

         FillXAttrib(GLX_RED_SIZE,ColorBits Div 4);
         FillXAttrib(GLX_GREEN_SIZE,ColorBits Div 4);
         FillXAttrib(GLX_BLUE_SIZE,ColorBits Div 4);
         FillXAttrib(GLX_ALPHA_SIZE,ColorBits Div 4);

         FillXAttrib(GLX_DEPTH_SIZE,ZBits);
         FillXAttrib(GLX_STENCIL_SIZE,StencilBits);
         FillXAttrib(GLX_AUX_BUFFERS,AuxBuffers);

         FillXAttrib(GLX_ACCUM_RED_SIZE,AccumBits Div 4);
         FillXAttrib(GLX_ACCUM_GREEN_SIZE,AccumBits Div 4);
         FillXAttrib(GLX_ACCUM_BLUE_SIZE,AccumBits Div 4);
         FillXAttrib(GLX_ACCUM_ALPHA_SIZE,AccumBits Div 4);

         FillXAttrib(GLX_LEVEL,Level);
      End;

      XVisualProperties:= glxChooseVisual
         (XDisplay, DefaultScreen(XDisplay), XAttrib);

      If XVisualProperties <> NIL
         Then Begin
            Result:= TRUE;
            InternSetAtoms;
         End
         Else Result:= FALSE;
   End;
End;
//********************************************************************
Procedure InternDisplayFinalize;
Begin
   XCloseDisplay(XDisplay);
End;
//********************************************************************
Function osDisplay: TPoint32;
Begin
   Result:= XDisplay;
End;
//********************************************************************
//   C L O C K
//********************************************************************
Function osClockFrequency: TInt64;
Begin
   Result:= 1;
End;
//********************************************************************
Function osClockTick: TInt64;
Var
   LTimeVal: TTimeVal;
   LFuncResult: TuInt32;
Begin
   LFuncResult:= fpGetTimeOfDay(@LTimeVal,NIL);
   With LTimeVal  Do
      Result:= Int64(tv_sec)*1000 + tv_usec Div 1000;
End;
//********************************************************************
//   C O P Y  &  P A S T E
//********************************************************************
Procedure InternClipboardSendText
               (AXRequestEvent: TXSelectionRequestEvent);
Var
   NewEvent: TXEvent;
   TextProp: TXTextProperty;
   TargetList: Array [0..1] Of TAtom;
   TargetOK: TBool8;
   LocalUTF8String: UTF8String;
Begin
   TargetOK:= FALSE;

   // Transmit info to clipboard
   With AXRequestEvent Do If Target = XA_TARGETS Then Begin

      TargetList[0]:= XA_TARGETS;
      TargetList[1]:= XA_UTF8_STRING;

      XChangeProperty(XDisplay,
         Requestor,
         _Property,
         Target,
         32, // Attention: do not use a variabe here
         PropModeReplace,
         @TargetList[0],
         2); // Attention: do not use a variabe here

      TargetOK:= TRUE;
   End;

   // Transmit data to clipboard
   With AXRequestEvent Do If Target = XA_STRING Then Begin
      LocalUTF8String:= UTF8Encode(XClipboard);
      XUTF8TextListToTextProperty(XDisplay, @LocalUTF8String, 1,
                 XUTF8StringStyle, @TextProp);
      XChangeProperty(XDisplay,
         Requestor,
         _Property,
         TextProp.Encoding,  //Target,
         TextProp.Format,    //SizeOf(UTF8Char),
         PropModeReplace,
         TextProp.Value,     //@XClipboard[1],
         TextProp.nitems);   //Length(XClipboard));

      TargetOK:= TRUE;
   End;

   // Send a notify event to let requestor know the data is arrived
   FillChar(NewEvent, SizeOf(TXEvent), #0);
   With AXRequestEvent Do Begin
      NewEvent._Type:= SelectionNotify;
      NewEvent.XSelection.Requestor:= Requestor;
      NewEvent.XSelection.Selection:= Selection;
      NewEvent.XSelection.Target:= Target;
      NewEvent.XSelection.Time:= Time;
      NewEvent.XSelection._Property:= _Property;
      If Not TargetOK
          Then NewEvent.XSelection._Property:= 0;
   End;

   XSendEvent(XDisplay,AXRequestEvent.Requestor,TRUE,0,@NewEvent);
   XFlush(XDisplay);
End;
//********************************************************************
Procedure osCopyString(AWindow: TuInt32; AString: TString8); // Unicode-Switch &&&&&
Var LocalOwner: TuInt32;
Begin
   XClipBoard:= AString;

   // Claim ownership of clipboard
   XSetSelectionOwner(XDisplay, XA_CLIPBOARD, AWindow, 0);
   LocalOwner:= XGetSelectionOwner(XDisplay,XA_CLIPBOARD);
   If LocalOwner <> AWindow
      Then;

   // Now we must wait for a Request event
End;
//********************************************************************
Function InternClipboardReceiveText
               (XSelectEvent: TXSelectionEvent): TBool8;
Var
   SelType: TAtom;
   SelFormat: TInt32;
   Len,Bytes_Left,Dummy: TuInt32;
   Data: PByte;
   Response: TInt32;
   LocalUTF8String: UTF8String;
Begin
   Result:= FALSE;

   // Check if there is data on the clipboard
   With XSelectEvent Do Begin
      Len:= 0;
      If _Property = XA_DATA_ATOM
         Then XGetWindowProperty(XDisplay, Requestor,
            _Property,       // XA_STRING
            0,1024,          // Data Offset, BufferSize
            TRUE,            // Data will be deleted
            AnyPropertyType, // Give me anything
            @SelType,        // Atom identifier = XA_STRING
            @SelFormat,      // Format = 8/16/32
            @Len,            // Data length
            @Bytes_Left,     // Bytes that have not been read yet
            @Data);          // ...

      If (Len > 0) And (SelType = XA_UTF8_STRING)
         Then Begin
            SetLength(LocalUTF8String,Len); // ?????
            Move(Data^,LocalUTF8String[1],Len);
            XClipBoard:= UTF8Decode(LocalUTF8String);
            XFree(Data);
            XDeleteProperty(XDisplay,Requestor,_Property);
            Result:= TRUE;
         End;
   End;
End;
//********************************************************************
Function osPasteString(AWindow: TuInt32): TString8; // Unicode-Switch &&&&&
Const TimeOut = 2000;
Var
   XEvent: TXEvent;
   SelOwner,Clock1,Clock: TuInt32;
   Done: TBool8;
Begin
   Result:= '';

   SelOwner:= XGetSelectionOwner(XDisplay, XA_CLIPBOARD);
   If SelOwner > 0 Then Begin
      If SelOwner <> AWindow Then Begin

         // Convert selection
         XA_DATA_ATOM:= XInternAtom(XDisplay, 'XA_DATA_ATOM', FALSE);
         XConvertSelection(XDisplay,
               //XA_CLIPBOARD, XA_STRING, XA_DATA_ATOM, AWindow, 0);
               XA_CLIPBOARD, XA_UTF8_STRING, XA_DATA_ATOM, AWindow, 0);

         // Wait for SelectionNotify event
         Clock1:= osClockTick;
         Clock:= 0;
         Done:= FALSE;
         FillChar(XEvent,SizeOf(XEvent),#0);
         While Not Done Do Begin

            While (Not Done) And (XEvent._Type<>SelectionNotify) Do
               Begin
                  If XPending(XDisplay) > 0
                     Then XNextEvent(XDisplay, @XEvent);
               End;
            Clock:= osClockTick-Clock1;
            If Clock > Timeout
               Then Done:= TRUE
               Else If XEvent._Type = SelectionNotify
                  Then Done:= InternClipboardReceiveText
                                (XEvent.XSelection)
         End;
      End;
      Result:= XClipboard;
   End;
End;
//********************************************************************
//   D I R E C T O R I E S
//********************************************************************
// Function osRootDir: see OSSupport.Inc
//********************************************************************
//   E V E N T S
//********************************************************************
Function osEventProcess(AWindow: TuInt32;
               WaitForMessage: TBool8): TBool8;
Var
   XEvent: TXEvent;
Begin
   Result:= FALSE;

   If WaitForMessage
      Then Begin
         XNextEvent(XDisplay, @XEvent);
         InternEventReceive(AWindow,XEvent);
         Result:= TRUE;
      End
      Else While XPending(XDisplay) > 0 Do Begin
         XNextEvent(XDisplay, @XEvent);
         InternEventReceive(AWindow,XEvent);
         Result:= TRUE;
      End;
End;
//********************************************************************
Procedure osEventTerminateApplication;
Begin
End;
//********************************************************************
//   M O U S E
//********************************************************************
Procedure osMouseCapture(AWindow: TuInt32);
Var Mask: TuInt32; LEventMask: TuInt32;
Begin
   LEventMask:= PointerMotionMask;

   XGrabPointer(XDisplay,AWindow,FALSE,LEventMask,
      GrabModeAsync,GrabModeAsync,None,0,CurrentTime);
End;
//********************************************************************
Procedure osMouseCaptureRelease;
Begin
   XUngrabPointer(XDisplay,CurrentTime);
End;
//********************************************************************
Procedure osMouseImageSet(AWindow: TuInt32; AMouseImage: TMouseImage);
Var
  XMCursor: TCursor;
  MImage: TInt32;
Begin
   MImage:= XC_arrow; // Default

   Case AMouseImage Of
      miHourGlass : MImage:= XC_watch;
      miIBeam     : MImage:= XC_xterm;
      miMoving    : MImage:= XC_fleur;
      miSizing    : MImage:= XC_bottom_right_corner;
      miCross     : MImage:= XC_cross;
   End;

   XMCursor:= XCreateFontCursor(XDisplay, MImage);
   XDefineCursor(XDisplay, AWindow, XMCursor);
   XFreeCursor(XDisplay, XMCursor);
End;
//********************************************************************
Function osMousePosition(AWindow: TuInt32): TPoint2D;
Var
   ParentWindow, RootReturn, Child, Dummy,
   RootX, RootY, ChildX, ChildY, Mask: TuInt32;
Begin
   ParentWindow:= RootWindow(XDisplay, XVisualProperties^.Screen);
   XQueryPointer(XDisplay,ParentWindow,@RootReturn, @Child,
      @RootX, @RootY, @ChildX, @ChildY, @Mask);

   With Result Do Begin X:= RootX; Y:= RootY; End;
End;
//********************************************************************
Procedure osMousePositionSet(AWindow: TuInt32; AX,AY: TInt32);
Begin
End;
//********************************************************************
//   R E N D E R I N G   C O N T E X T
//********************************************************************
Function osRenderContextCreate
               (AWindow,ASharedContext: TuInt32): TuInt32;
Var LocalContext: Pointer;
Begin
   LocalContext:= glxCreateContext(XDisplay,
             XVisualProperties,Pointer(ASharedContext),TRUE);

   // First map window, then activate rendering context
   osWindowDisplay(AWindow,TRUE);
   osRenderContextActivate(AWindow,TuInt32(LocalContext));

   Result:= TuInt32(LocalContext);
End;
//********************************************************************
Function osRenderContextDestroy
               (AWindow,ARenderContext: TuInt32): TBool8;
Begin
   osRenderContextActivate(AWindow,ARenderContext);
   glxDestroyContext(XDisplay,Pointer(ARenderContext));
End;
//********************************************************************
Function osRenderContextActivate
               (AWindow,ARenderContext: TuInt32): TBool8;
Begin
   Result:= glxMakeCurrent(XDisplay,AWindow,Pointer(ARenderContext));
End;
//********************************************************************
Procedure osRenderContextDeactivate;
Begin
   glxMakeCurrent(XDisplay,0,NIL);
End;
//********************************************************************
Function osGetCurrentContext: TuInt32;
Begin
   Result:= TuInt32(glxGetCurrentContext);
End;
//********************************************************************
//   V I D E O M O D E
//********************************************************************
Function osVideoSettings: TVideoSettings;
Var
   ParentWindow: TuInt32;
   CurScreen: PScreen;
   CurConfig: PXRRScreenConfiguration;
   Rotation: TRotation;
   SizeInfo: PXRRScreenSize;
   SizeCount,SizeID: TInt32;
   Rate: TInt16;
Begin
   FillChar(Result, SizeOf(TVideoSettings), #0);

   If XDisplay <> NIL Then Begin
      CurScreen:= XScreenOfDisplay(XDisplay,0);
      ParentWindow:= RootWindow(XDisplay, XVisualProperties^.Screen);
      CurConfig:= XRRGetScreenInfo(XDisplay,ParentWindow);
      SizeInfo:= XRRConfigSizes(CurConfig,@SizeCount);
      SizeID:= XRRConfigCurrentConfiguration(CurConfig,@Rotation);
      Rate:= XRRConfigCurrentRate(CurConfig);
      Inc(SizeInfo,SizeID);

      With Result Do Begin
         BitsPerPixel:= CurScreen^.Root_Depth;
         Width:= SizeInfo^.Width;
         Height:= SizeInfo^.Height;
         Frequency:= Rate;
      End;

      XRRFreeScreenConfigInfo(CurConfig);
   End;
End;
//********************************************************************
//   W I N D O W S
//********************************************************************
Function osWindowCreate(AWindowType: TWindowType;
               ACaption: TString8; // Unicode-Switch &&&&&
               ALeft,ATop,AWidth,AHeight: TInt32): TuInt32;
Type
   TMotifHints = Packed Record
      Flags      : TuInt32;
      Functions  : TuInt32;
      Decorations: TuInt32;
      InputMode  : Longint;
      Status     : TuInt32;
   End;

Var
   LocalWindow,ParentWindow: TuInt32;
   ColorMap: TColorMap;
   WinAttrib: TXSetWindowAttributes;
   AttribMask: TuInt32;
   XSizeHints: TXSizeHints;
   MotifHints: TMotifHints;

Begin
   Result:= 0;

   ParentWindow:= RootWindow(XDisplay, XVisualProperties^.Screen);

   // Create a new ColorMap
   ColorMap:= XCreateColorMap
      (XDisplay, ParentWindow, XVisualProperties^.Visual, AllocNone);

   // Set window attributes
   WinAttrib.Colormap:= ColorMap;
   WinAttrib.Border_Pixel:= 0;
   WinAttrib.Background_Pixel:= 0;
   WinAttrib.Override_Redirect:= FALSE;
   {If AWindowType <> wtPopup
      Then WinAttrib.Override_Redirect:= FALSE
      Else WinAttrib.Override_Redirect:= TRUE; }

   WinAttrib.Event_Mask:=
      StructureNotifyMask Or     // Any change in structure
      PropertyChangeMask Or      // This is for Copy&Paste
      ExposureMask Or            // Draw window
      ButtonPressMask Or         // Mouse press
      ButtonReleaseMask Or       // Mouse release
      PointerMotionMask Or       // MouseMove
      KeyPressMask Or            // Key press
      KeyReleaseMask;            // Key release

   AttribMask:=
      CWBorderPixel Or
      CWColormap Or
      CWEventmask Or
      CWOverrideRedirect;

   // Create window
   LocalWindow:= XCreateWindow
     (XDisplay, ParentWindow,    // XDisplay, Parent
      0, 0, AWidth, AHeight,     // Measures are set afterwards
      0,                         // BorderWidth
      XVisualProperties^.Depth,  // Colordepth
      InputOutput,               // InputOutput class
      XVisualProperties^.Visual, // Visual properties
      AttribMask,                // Attributes #1
      @WinAttrib);               // Attributes #2


   // Set window without titlebar ------------------------------------
   If (MOTIF_WM_HINTS <> 0)
      Then Begin
         With MotifHints Do Begin
            Flags      := MWM_HINTS_DECO;
            Functions  := 0;
            Decorations:= 0;
            InputMode  := 0;
            Status     := 0;
         End;
         XChangeProperty(XDisplay, LocalWindow, MOTIF_WM_HINTS,
            MOTIF_WM_HINTS, 32, PropModeReplace, @MotifHints,
            SizeOf(MotifHints) Div 4);
      End;

   // Set Popup window type ------------------------------------------
   If (AWindowType = wtPopup) And (NET_WM_WINDOW_TYPE <> 0)
      Then Begin
         XChangeProperty(XDisplay, LocalWindow, NET_WM_WINDOW_TYPE,
         NET_WM_WINDOW_TYPE, 32, PropModeReplace,
         @NET_WM_WINDOW_TYPE_NORMAL,
         SizeOf(NET_WM_WINDOW_TYPE_NORMAL) Div 4);

         // Popup windows should not be resizeable
         FillChar(XSizeHints ,SizeOf(TXSizeHints), #0);
         With XSizeHints Do Begin
            Flags:= PMinSize Or PMaxSize;
            Min_Width := AWidth;
            Min_Height:= AHeight;
            Max_Width := AWidth;
            Max_Height:= AHeight;
         End;
         XSetWMSizeHints(XDisplay,LocalWindow,@XSizeHints,XA_WM_NORMAL_HINTS);
      End;

   // Set Standard window type ---------------------------------------
   If (AWindowType = wtStandard) {Or (AWindowType = wtNative))} And
      (NET_WM_WINDOW_TYPE <> 0)
      Then XChangeProperty(XDisplay, LocalWindow, NET_WM_WINDOW_TYPE,
         NET_WM_WINDOW_TYPE, 32, PropModeReplace,
         @NET_WM_WINDOW_TYPE_NORMAL,
         SizeOf(NET_WM_WINDOW_TYPE_NORMAL) Div 4);

   // Set Fullscreen window type -------------------------------------
   If (AWindowType = wtFullScreen) And (NET_WM_STATE <> 0)
      Then XChangeProperty(XDisplay, LocalWindow, NET_WM_STATE,
         XA_ATOM, 32, PropModeReplace, @NET_WM_STATE_FULLSCREEN,
         SizeOf(NET_WM_STATE_FULLSCREEN) Div 4);

   // Set window title -----------------------------------------------
   osWindowCaption(LocalWindow,ACaption);

   Result:= LocalWindow;
End;
//********************************************************************
Procedure osWindowDestroy(AWindow: TuInt32);
Begin
   XDestroyWindow(XDisplay, AWindow);
End;
//********************************************************************
Procedure osWindowCaption(AWindow: TuInt32; ACaption: TString8);
Var
   Caption_Property: TXTextProperty;
   CaptionUTF8: UTF8String;
Begin
   If Length(ACaption) > 0 Then Begin

      CaptionUTF8:= UTF8Encode(ACaption);
      Xutf8TextListToTextProperty(XDisplay, @CaptionUTF8, 1,
                 XUTF8StringStyle, @Caption_Property);

      XSetWMName(XDisplay, AWindow, @Caption_Property);
   End;
End;
//********************************************************************
Procedure osWindowDisplay(AWindow: TuInt32; Visible: TBool8);
Begin
   XMapWindow(XDisplay, AWindow);
End;
//********************************************************************
Procedure osWindowMaximize(AWindow: TuInt32);
Begin
   InternStateChange(AWindow,
                     NET_WM_STATE_MAXIMIZED_HORZ,
                     NET_WM_STATE_MAXIMIZED_VERT);
End;
//********************************************************************
Procedure osWindowMinimize(AWindow: TuInt32);
Begin
   XIconifyWindow(XDisplay,AWindow,0);
End;
//********************************************************************
Procedure osWindowMove(AWindow: TuInt32; ALeft,ATop: TInt32);
Begin
   XMoveWindow(XDisplay, AWindow, ALeft, ATop);
End;
//********************************************************************
Procedure osWindowResize(AWindow: TuInt32; AWidth,AHeight: TInt32);
Begin
   XResizeWindow(XDisplay, AWindow, AWidth, AHeight);
End;
//********************************************************************
Procedure osWindowRestore(AWindow: TuInt32;
               ALeft,ATop,AWidth,AHeight: TInt32);
Begin
   InternStateChange(AWindow,
                     NET_WM_STATE_MAXIMIZED_HORZ,
                     NET_WM_STATE_MAXIMIZED_VERT);
End;
//********************************************************************
Procedure osWindowSwapBuffers(AWindow: TuInt32);
Begin
   glxSwapBuffers(XDisplay,AWindow);
End;
//********************************************************************
// "S P E C I A L" - Windows routines (for MS-Windows only)
//********************************************************************
// Move window by left mousebutton + "ALT"
Procedure osWindowSpecialMove(AWindow: TuInt32; MouseX,MouseY: TInt32);
Var XEvent: TXEvent; XMask: TuInt32;
Begin
   XMask:=
      StructureNotifyMask Or     // Any change in structure
      ExposureMask Or            // Draw window
      ButtonPressMask Or         // Mouse press
      PointerMotionMask;       // MouseMove

   While XCheckMaskEvent(XDisplay, XMask, @XEvent) Do;
End;
//********************************************************************
// Resize window by second mousebutton (= mousewheel) + "ALT"
Procedure osWindowSpecialResize(AWindow: TuInt32; MouseX,MouseY: TInt32);
Begin
End;
//********************************************************************
//   I N T E R N   R O U T I N E S
//********************************************************************
{DirEnt = Packed Record
            d_FileNo: ino64_t;   // file number of entry
            d_Off   : off_t;     // Offset?
            d_RecLen: cushort;   // length of string in d_Name
            d_Type  : cuchar;    // file type, see details
            d_Name  : array[0..(255 + 1)-1] of char;
         End;                    // name must be no longer than this

File type, details:
-------------------
Directories: file type = 4 (including "." and "..")
Files: file type = 8
}
Procedure InternGetRootDir;
Var
   DirPtr: PDir;
   EntryPtr: PDirEnt;
   DriveName: TString8;
   DriveType: TuInt32;
Begin
   DirPtr:= NIL;
   //DirPtr:= OpenDir('./.');  // = current dir
   DirPtr:= OpenDir('/.');  // = RootDir dir
   SetLength(DriveName,256);
   Repeat
      EntryPtr:= NIL;
      EntryPtr:= ReadDir(DirPtr);
      If EntryPtr <> NIL Then Begin
          DriveName:= EntryPtr^.d_Name;
          DriveType:= EntryPtr^.d_type;
          If (DriveType = 4)  // Directories
             Then RootDir.Add(DriveName);
      End;
   Until EntryPtr = NIL;

   CloseDir(DirPtr);
   RootDir.Sort;
End;
//********************************************************************
Procedure InternEventReceive(AWindow: TuInt32; AXEvent: TXEvent);
Const
   MOUSE_LEFTBTN   = 1;
   MOUSE_MIDDLEBTN = 2;
   MOUSE_RIGHTBTN  = 3;
   MOUSE_WHEELUP   = 4;
   MOUSE_WHEELDOWN = 5;
Var
   SystemKey: TuInt32; LocalKey: TInt32;
Begin
   With EventPipeline Do Case AXEvent._Type Of

      // Resize ---------------------------------------------------
      ConfigureNotify: If Assigned(OnResize)
                          Then With AXEvent.XConfigure Do
                             OnResize(Window,Width,Height);
      // Map ------------------------------------------------------
            MapNotify: If Assigned(OnRestore)
                          Then With AXEvent.XMap Do
                             OnRestore(Window);
      // Paint ----------------------------------------------------
               Expose: If Assigned(OnPaint)
                          Then OnPaint(AXEvent.XExpose.Window);
      // Selection ------------------------------------------------
      // SelectionNotify: See Function "osPaste"
     SelectionRequest: Begin
                          With AXEvent.XSelectionRequest Do
                          If (Selection = XA_CLIPBOARD) And
                             (_Property > 0)
                             Then InternClipboardSendText
                                (AXEvent.XSelectionRequest);
                       End;
      // Mouse button&wheel ---------------------------------------
          ButtonPress: Begin
                          Case AXEvent.XButton.Button Of

                          MOUSE_LEFTBTN: If Assigned(OnMouseBtnLDown)
                             Then With AXEvent.XButton Do
                                OnMouseBtnLDown(Window,X,Y,0);

                          MOUSE_MIDDLEBTN: If Assigned(OnMouseBtnMDown)
                             Then With AXEvent.XButton Do
                                OnMouseBtnMDown(Window,X,Y,0);

                          MOUSE_RIGHTBTN: If Assigned(OnMouseBtnRDown)
                             Then With AXEvent.XButton Do
                                OnMouseBtnRDown(Window,X,Y,0);

                          MOUSE_WHEELUP: If Assigned(OnMouseWheelUp)
                             Then With AXEvent.XButton Do
                                OnMouseWheelUp(Window,X,Y,0);

                          MOUSE_WHEELDOWN: If Assigned(OnMouseWheelDown)
                             Then With AXEvent.XButton Do
                                OnMouseWheelDown(Window,X,Y,0);

                          End; // Of Case
                       End;
        ButtonRelease: Begin
                          Case AXEvent.XButton.Button Of

                          MOUSE_LEFTBTN: If Assigned(OnMouseBtnLUp)
                             Then With AXEvent.XButton Do
                                OnMouseBtnLUp(Window,X,Y,0);

                          MOUSE_MIDDLEBTN: If Assigned(OnMouseBtnMUp)
                             Then With AXEvent.XButton Do
                                OnMouseBtnMUp(Window,X,Y,0);

                          MOUSE_RIGHTBTN: If Assigned(OnMouseBtnRUp)
                             Then With AXEvent.XButton Do
                                OnMouseBtnRUp(Window,X,Y,0);

                          End; // Of Case
                       End;
      // Mouse motion ---------------------------------------------
         MotionNotify: If Assigned(OnMouseMove)
                          Then With AXEvent.XButton Do
                             OnMouseMove(Window,X,Y);
      // Keyboard -------------------------------------------------
             KeyPress: If Assigned(OnKeyDown)
                          Then With AXEvent.XKey Do Begin
                             XLookupString(@AXEvent.XKey,NIL,0,@SystemKey,NIL);
                             LocalKey:= InternTranslateKey(SystemKey);
                             OnKeyDown(Window,LocalKey,PreviousKey);
                             PreviousKey:= LocalKey;
                          End;
           KeyRelease: If Assigned(OnKeyUp)
                          Then With AXEvent.XKey Do Begin
                             SystemKey:= XLookupKeySym(@AXEvent,0);
                             LocalKey:= InternTranslateKey(SystemKey);
                             OnKeyUp(Window,LocalKey,PreviousKey);
                          End;
      // Not processed --------------------------------------------
         Else;

   End; // Of Case
End;
//********************************************************************
Procedure InternSetAtoms;
Begin
   // For some reason unknown only to immortals, XA_CLIPBOARD is not
   // an internal atom defined in Xatom.h
   XA_ATOM     := XInternAtom(XDisplay, 'ATOM', FALSE);
   XA_CLIPBOARD:= XInternAtom(XDisplay, 'CLIPBOARD', FALSE);
   XA_TARGETS  := XInternAtom(XDisplay, 'TARGETS', FALSE);

   // Window manager motif hints
   MOTIF_WM_HINTS:= XInternAtom(XDisplay,'_MOTIF_WM_HINTS',FALSE);

   // Window manager type hints
   NET_WM_WINDOW_TYPE:= XInternAtom(XDisplay,'_NET_WM_WINDOW_TYPE',FALSE);
   NET_WM_WINDOW_TYPE_NORMAL:= XInternAtom(XDisplay,'_NET_WM_WINDOW_TYPE_NORMAL',FALSE);

   // Window manager state hints
   NET_WM_STATE:= XInternAtom(XDisplay,'_NET_WM_STATE',FALSE);
   NET_WM_STATE_MAXIMIZED_HORZ:= XInternAtom(XDisplay,'_NET_WM_STATE_MAXIMIZED_HORZ',FALSE);
   NET_WM_STATE_MAXIMIZED_VERT:= XInternAtom(XDisplay,'_NET_WM_STATE_MAXIMIZED_VERT',FALSE);
   NET_WM_STATE_FULLSCREEN:= XInternAtom(XDisplay,'_NET_WM_STATE_FULLSCREEN',FALSE);

   // TextTypes
   XA_STRING:= XInternAtom(XDisplay,'STRING',FALSE);
   XA_TEXT:= XInternAtom(XDisplay,'TEXT',FALSE);
   XA_COMPOUND_TEXT:= XInternAtom(XDisplay,'COMPOUND_TEXT',FALSE);
   XA_UTF8_STRING:= XInternAtom(XDisplay,'UTF8_STRING',FALSE);
End;
//********************************************************************
Procedure InternStateChange(AWindow: TuInt32; State1,State2: TAtom);
Var
   LEvent: TXClientMessageEvent;
   ParentWindow: TuInt32;
Begin
   If (NET_WM_STATE <> 0) And (State1 <> 0) Then Begin

      FillChar(LEvent,SizeOf(LEvent),0);

      With LEvent Do Begin
         _Type:= ClientMessage;
         Send_Event:= TRUE;
         Display:= XDisplay;
         Window:= AWindow;
         Message_type:= NET_WM_STATE;
         Format:= 32;
         Data.l[0]:= _NET_WM_STATE_TOGGLE;
         Data.l[1]:= State1;
         Data.l[2]:= State2;
         Data.l[3]:= _NET_SOURCE_APPLICATION;
      End;

      ParentWindow:= RootWindow(XDisplay, XVisualProperties^.Screen);
      XSendEvent(XDisplay, ParentWindow, TRUE,
         SubstructureNotifyMask Or SubstructureRedirectMask,@LEvent);
   End;
End;
//********************************************************************
Function InternTranslateKey(AKey: TuInt32): TInt32;
Begin
   Case AKey Of
      XK_BACKSPACE: Result:= FK_BACK;
      XK_TAB: Result:= FK_TAB;
      XK_CLEAR: Result:= FK_CLEAR;
      XK_RETURN: Result:= FK_RETURN;
      XK_PAUSE: Result:= FK_PAUSE;
      XK_SCROLL_LOCK: Result:= FK_SCROLL;
      XK_ESCAPE: Result:= FK_ESCAPE;
      XK_DELETE: Result:= FK_DELETE;
      XK_HOME: Result:= FK_HOME;
      XK_END: Result:= FK_END;
      XK_PRIOR: Result:= FK_PRIOR;
      XK_NEXT: Result:= FK_NEXT;
      XK_LEFT: Result:= FK_LEFT;
      XK_UP: Result:= FK_UP;
      XK_RIGHT: Result:= FK_RIGHT;
      XK_DOWN: Result:= FK_DOWN;

      XK_Shift_L,XK_Shift_R: Begin
         Result:= FK_SHIFT;
         If ButtonState <> bsShift
            Then ButtonState:= bsShift
            Else ButtonState:= bsNone;
      End;
      XK_Control_L,XK_Control_R: Begin
         Result:= FK_CONTROL;
         If ButtonState <> bsControl
            Then ButtonState:= bsControl
            Else ButtonState:= bsNone;
      End;
      XK_ALT_L,XK_ALT_R: Begin
         Result:= FK_ALT;
         If ButtonState <> bsAlt
            Then ButtonState:= bsAlt
            Else ButtonState:= bsNone;
      End;
      //XK_SPACE: Result:= FK_SPACE;
      XK_INSERT: Result:= FK_INSERT;
      //XK_UNDO: Result:= FK_UNDO;
      XK_NUM_LOCK: Result:= FK_NUMLOCK;
      XK_CAPS_Lock: Result:= FK_CAPITAL;
      XK_SHIFT_Lock: Result:= FK_CAPITAL;

      XK_F1: Result:= FK_F1;
      XK_F2: Result:= FK_F2;
      XK_F3: Result:= FK_F3;
      XK_F4: Result:= FK_F4;
      XK_F5: Result:= FK_F5;
      XK_F6: Result:= FK_F6;
      XK_F7: Result:= FK_F7;
      XK_F8: Result:= FK_F8;
      XK_F9: Result:= FK_F9;
      XK_F10: Result:= FK_F10;
      XK_F11: Result:= FK_F11;
      XK_F12: Result:= FK_F12;

      XK_KP_0: Result:= FK_NUMPAD0;
      XK_KP_1: Result:= FK_NUMPAD1;
      XK_KP_2: Result:= FK_NUMPAD2;
      XK_KP_3: Result:= FK_NUMPAD3;
      XK_KP_4: Result:= FK_NUMPAD4;
      XK_KP_5: Result:= FK_NUMPAD5;
      XK_KP_6: Result:= FK_NUMPAD6;
      XK_KP_7: Result:= FK_NUMPAD7;
      XK_KP_8: Result:= FK_NUMPAD8;
      XK_KP_9: Result:= FK_NUMPAD9;
      XK_KP_Multiply: Result:= FK_MULTIPLY;
      XK_KP_Add: Result:= FK_ADD;
      XK_KP_Separator: Result:= FK_SEPARATOR;
      XK_KP_Subtract: Result:= FK_SUBTRACT;
      XK_KP_Decimal: Result:= FK_DECIMAL;
      XK_KP_Divide: Result:= FK_DIVIDE;

      Ord('z'): If ButtonState = bsControl
         Then Result:= FK_UNDO
         Else Result:= AKey;

      Else Result:= TInt32(AKey);

   End; //Of Case
End;
//********************************************************************

