{ THIS FILE IS PART OF THE glPasGUI-PROJECT.

Copyright (c) 2009, Mag.Gertraude Trawnicek, Austria
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
      copyright notice, this list of conditions and the following
      disclaimer in the documentation and/or other materials provided
      with the distribution.
    * The name of the copyright holder must not be used to endorse
      or promote products derived from this software without specific
      prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES,INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}
//********************************************************************
UNIT StdBasicDefs;
// 1.Description: Basic type definitions/procedures/functions/objects
// 2.Defined objects: TIDObject, TFiledObject
// 3.Dependencies: None
// 4.Limitations: None
// 5.Note: None
//********************************************************************
INTERFACE

USES
   SysUtils,Classes,Contnrs;
//********************************************************************
CONST
   MAX_EXTENSIONS = 4;
   MAX_ARRAY_INDEX =  High(Word); // 65536
   MAX_PICTURE_SIZE = High(Integer);
   TOLERANCE = 0.01;
   EMPTYSTRING = '';
   BLANK = ' ';
   SEMICOLON = ';';
   SLASH = '/';

{$ifopt R+}
   {$define RangeCheckWasOn}
   {$R-}
{$endif opt R+}

{$ifopt Q+}
   {$define OverflowCheckWasOn}
   {$Q-}
{$endif opt Q+}
NAN32: Single = 0.0/0.0;
{$ifdef OverflowCheckWasOn}
   {$Q+}
   {$undef OverflowCheckWasOn}
{$endif}
{$ifdef RangeCheckWasOn}
   {$R+}
   {$undef RangeCheckWasOn}
{$endif}
//********************************************************************
TYPE
   EIdentityError = Exception;
   ELimitError = Exception;

   TBool8 = Boolean;    // 1 byte
//********************************************************************
   TuInt8  = Byte;      // 1 byte  [0..255]
   TuInt16 = Word;      // 2 bytes [0..65.535]
   TuInt32 = Longword;  // 4 bytes [0..4.294.967.295]
   PuInt8 = ^TuInt8;
//********************************************************************
   TInt8  = ShortInt;   // 1 byte  [-128..127]
   TInt16 = SmallInt;   // 2 bytes [-32.768..+32.767]
   TInt32 = Longint;    // 4 bytes [-2.147.483.648..+2.147.483.647]
   TInt64 = Int64;      // 8 bytes [-2^63..2^63-1]
//********************************************************************
   TFloat32 = Single;   // 4 bytes
   TFloat64 = Double;   // 8 bytes
//********************************************************************
   TChar8 = AnsiChar;
   PChar8 = ^AnsiChar;
   //TChar16 = WideChar;
   //PChar16 = ^WideChar;
   TString8 = AnsiString;
   //TString16 = WideString;
   TPoint32 = Pointer;
   TVariant32 = Array[0..3] Of TuInt8;

CONST EMPTYVARIANT: TVariant32 = (0,0,0,0);
//********************************************************************
TYPE

   TBool8Array = Array Of TBool8;
   TInt32Array = Array Of TInt32;
   TFloat32Array = Array Of TFloat32;
   TPoint32Array = Array Of TPoint32;
   TString8Array = Array Of TString8;
   //TString16Array = Array Of TString16;

//********************************************************************
TYPE
{$MINENUMSIZE 2}

   TStdDataType = (

            dtInvalid =   0,
            dtUnknown =   1,

              dtBool8 = 100,
             dtBool16 = 110,
             dtBool32 = 120,

              dtuInt8 = 200,
             dtuInt16 = 210,
             dtuInt32 = 220,
             dtuInt64 = 230,

               dtInt8 = 300,
              dtInt16 = 310,
              dtInt32 = 320,
              dtInt64 = 330,

            dtFloat32 = 400,
            dtFloat64 = 410,

            dtString8 = 500,
           dtString16 = 510,
           dtString32 = 520,

            dtPoint32 = 600,
            dtPoint64 = 610,

         dtBool8Array = 109,
         dtInt32Array = 329,
       dtFloat32Array = 409,
       dtString8Array = 509,
       dtPoint32Array = 609
      );

{$MINENUMSIZE 1} // Return to default

   TStdVarData = Record
      DataType: TStdDataType; // 4 Byte
      Data: TVariant32;       // 4 Byte
   End;
//********************************************************************
   TuInt8Array = Array Of TuInt8;
   TuInt16Array = Array Of TuInt16;
   TuInt32Array = Array Of TuInt32;
//********************************************************************
   TuInt16Rec = Packed Record Low,High: TuInt8; End;
   TuInt32Rec = Packed Record Low,High: TuInt16; End;
   TStdExtensions = Array [0..(MAX_EXTENSIONS-1)]
                   Of Array [0..2] Of TChar8;
//********************************************************************
   TPixelFormat = (pfNone,pfLumen,pfLumenWithAlpha,pfRGB,pfRGBA);
   TImageFormat = (ifUnknown, ifBMP, ifTGA, ifJPG, ifWLT);
   TImageInfo = Record
      ImageFormat: TImageFormat;
      PixelFormat: TPixelFormat;
      HeightInPixels: TuInt16;
      WidthInPixels: TuInt16;
      OriginalHeight: TuInt16;
      OriginalWidth: TuInt16;
   End;
   T8bColor  = TuInt8;
   T16bColor = Packed Record Lumen,Alpha: TuInt8; End;
   T24bColor = Packed Record Red,Green,Blue: TuInt8; End;
   T32bColor = Packed Record Red,Green,Blue,Alpha: TuInt8; End;
   P32bColor = ^T32bColor;
//********************************************************************
// NB.: "S"=SOLID, "T"=TRANSPARENT, "M"=MUTED, "L"=LIGHT, "D"=DARK
CONST
   SWHITE    :  T32bColor = (Red:255; Green:255; Blue:255; Alpha:255);
   SBLACK    :  T32bColor = (Red:  0; Green:  0; Blue:  0; Alpha:255);
   SGREY     :  T32bColor = (Red:128; Green:128; Blue:128; Alpha:255);
   SRED      :  T32bColor = (Red:255; Green:  0; Blue:  0; Alpha:255);
   SGREEN    :  T32bColor = (Red:  0; Green:255; Blue:  0; Alpha:255);
   SBLUE     :  T32bColor = (Red:  0; Green:  0; Blue:255; Alpha:255);

   TWHITE    :  T32bColor = (Red:255; Green:255; Blue:255; Alpha:128);
   TBLACK    :  T32bColor = (Red:  0; Green:  0; Blue:  0; Alpha:128);
   TGREY     :  T32bColor = (Red:128; Green:128; Blue:128; Alpha:128);
   TRED      :  T32bColor = (Red:255; Green:  0; Blue:  0; Alpha:128);
   TGREEN    :  T32bColor = (Red:  0; Green:255; Blue:  0; Alpha:128);
   TBLUE     :  T32bColor = (Red:  0; Green:  0; Blue:255; Alpha:128);

   MRED      :  T32bColor = (Red:255; Green:128; Blue:128; Alpha:255);
   MGREEN    :  T32bColor = (Red:128; Green:255; Blue:128; Alpha:255);
   MBLUE     :  T32bColor = (Red:128; Green:128; Blue:255; Alpha:255);

   SYELLOW   :  T32bColor = (Red:255; Green:255; Blue:  0; Alpha:255);
   SVIOLET   :  T32bColor = (Red:255; Green:  0; Blue:255; Alpha:255);
   STURQUOIS :  T32bColor = (Red:  0; Green:255; Blue:255; Alpha:255);

   SORANGE   :  T32bColor = (Red:255; Green:128; Blue:  0; Alpha:255);
   SVERMILION:  T32bColor = (Red:255; Green: 32; Blue:  0; Alpha:255);
   SCARMINRED:  T32bColor = (Red:224; Green:  0; Blue: 32; Alpha:255);
   SOCHRE    :  T32bColor = (Red:194; Green:120; Blue:  0; Alpha:255);
   LOCHRE    :  T32bColor = (Red:240; Green:160; Blue:  0; Alpha:255);
   SBROWN    :  T32bColor = (Red:160; Green: 64; Blue:  0; Alpha:255);
   SYELLGREEN:  T32bColor = (Red:160; Green:255; Blue:  0; Alpha:255);
   SBLUEGREEN:  T32bColor = (Red:  0; Green:160; Blue:160; Alpha:255);
   SHOOKGREEN:  T32bColor = (Red:  0; Green:184; Blue: 32; Alpha:255);
   SPRUSSBLUE:  T32bColor = (Red:  0; Green: 96; Blue:255; Alpha:255);
   SUMBER    :  T32bColor = (Red: 64; Green: 72; Blue: 64; Alpha:255);
   SLGREY    :  T32bColor = (Red:192; Green:192; Blue:192; Alpha:255);
   SDGREY    :  T32bColor = (Red: 64; Green: 64; Blue: 64; Alpha:255);
//********************************************************************
TYPE
   T8bColorArray = Array Of T8bColor;
   T16bColorArray = Array Of T16bColor;
   T24bColorArray = Array Of T24bColor;
   T32bColorArray = Array Of T32bColor;
//********************************************************************
   TPoint2D = Record X,Y: TInt32 End;
   TTexVertex2D = Record TexX,TexY,X,Y: TFloat32; End;
   PTexVertex2D = ^TTexVertex2D;
   TContour = Array Of TTexVertex2D;
   TBoundingBox = Packed Record Left,Top,Width,Height: TInt32; End;
//********************************************************************
   TIDObject = Class(TObject)
   Private
      fName: TString8;
      fRefCount: TuInt32;
   Protected
      Procedure SetName(AName: TString8); Virtual;
   Public
      Property RefCount: TuInt32 Read fRefCount;

      Constructor Create(AName: TString8); Reintroduce; Virtual;
       Function Identify(AName: TString8;
                   Params: Array Of Const): TBool8; Virtual;
      Procedure AddRefCount;
      Procedure DecRefCount;
   Published
      Property Name: TString8 Read fName Write SetName;
   End;
//********************************************************************
   TFiledObject = Class(TIDObject)
   Private
      fFileName: TString8;
   Protected
      Procedure SetFileName(AFileName: TString8);
   Published
      Property FileName: TString8 Read fFileName Write SetFileName;
   End;
//********************************************************************
Function IsBitSet(Const AValue: TuInt8; Const ABit: TuInt8): Boolean;
Function BitOn(Const AValue: TuInt8; Const ABit: TuInt8): TuInt8;
Function BitOff(Const AValue: TuInt8; Const ABit: TuInt8): TuInt8;
Function BitToggle(Const AValue: TuInt8; Const ABit: TuInt8): TuInt8;
//********************************************************************
Function BBoxHit(X,Y: TInt32; ABoundingBox: TBoundingBox): TBool8;
Procedure CrackUpString(AString: TString8; AStringList: TStringList;
          ASeparator: TChar8; Const ConsiderEmptyStrings: TBool8);
Function FormatInt(AInteger: TInt32; ALength: TuInt8): TString8;
Function GetFileExt(AFileName: TString8): TString8;
Function GetFileNameWithoutExt(AFileName: TString8): TString8;
Function IsPowerOf2(AValue: TuInt16): TBool8;
Function NextPowerOf2(AValue: TuInt16): TuInt32;
Function ColorToCardinal(AColor: T32bColor): TuInt32;
Function CardinalToColor(ACardinal: TuInt32): T32bColor;
Function GetColorByString(AColorString: ShortString): T32bColor;
Function SetColorByGradient(AColor: T32bColor;
                AGradient: TFloat32): T32bColor;
Function QuickFloat(AString: String): TFloat32;
Function ValidFileExt(AFileName: TString8;
                ValidExtensions: TStdExtensions): TBool8;
Function ValidFileName(AFileName: TString8;
                ValidExtensions: TStdExtensions): TBool8;
//********************************************************************
Function GetImgDataSize(PixelFormat: TPixelFormat;
                WidthInPixels,HeightInPixels: TuInt16): TuInt32;
Function GetImgPixelSize
               (WidthInPixels,HeightInPixels: TuInt16): TuInt32;
//********************************************************************
IMPLEMENTATION
//********************************************************************
Constructor TIDObject.Create(AName: TString8);
Begin
   SetName(AName);
   fRefCount:= 0;
End;
//********************************************************************
Function TIDObject.Identify(AName: TString8;
                   Params: Array Of Const): TBool8;
Begin
   If fName = AName
      Then Result:= TRUE
      Else Result:= FALSE;
End;
//********************************************************************
Procedure TIDObject.SetName(AName: TString8);
Begin
   If Length(AName) > 0
      Then fName:= UpperCase(AName)
      Else Raise EIdentityError.Create('No objectname specified');
End;
//********************************************************************
Procedure TIDObject.AddRefCount;
Begin
   Inc(fRefCount);
End;
//********************************************************************
Procedure TIDObject.DecRefCount;
Begin
   If fRefCount > 0
      Then Dec(fRefCount);
End;
//********************************************************************
Procedure TFiledObject.SetFileName(AFileName: TString8);
Begin
   If Length(AFileName) > 0
      Then fFileName:= AFileName;
End;
//********************************************************************
//********************************************************************
Function IsBitSet(Const AValue: TuInt8; Const ABit: TuInt8): Boolean;
Begin
   Result:= (AValue And (1 Shl ABit)) <> 0;
End;
//********************************************************************
Function BitOn(Const AValue: TuInt8; Const ABit: TuInt8): TuInt8;
Begin
   Result:= AValue Or (1 Shl ABit);
End;
//********************************************************************
Function BitOff(Const AValue: TuInt8; Const ABit: TuInt8): TuInt8;
Begin
   //Result:= AValue And ((1 Shl ABit) Xor $FFFFFFFF);
   Result:= AValue And ((1 Shl ABit) Xor $FF);
End;
//********************************************************************
Function BitToggle(Const AValue: TuInt8; Const ABit: TuInt8): TuInt8;
Begin
   Result:= AValue Xor (1 Shl ABit);
End;
//********************************************************************
//********************************************************************
Function BBoxHit(X,Y: TInt32; ABoundingBox: TBoundingBox): TBool8;
Begin
   With ABoundingBox Do Begin
      If (X >= Left) And (X <= Left+Width) And
         (Y >= Top) And (Y <= Top+Height)
         Then Result:= TRUE
         Else Result:= FALSE;
   End;
End;
//********************************************************************
// This procedure brakes a C(omma) S(eparated) V(alue)-string in its
// parts and puts it in a StringList
Procedure CrackUpString(AString: TString8; AStringList: TStringList;
          ASeparator: TChar8; Const ConsiderEmptyStrings: TBool8);
Var FirstPos, LinePos, ItemLen, StrgLen: Word; Interim: TString8;
//--------------------------------------------------------------------
Function EOS: Boolean; // End Of String
Begin If LinePos <= StrgLen Then EOS:= FALSE Else EOS:= TRUE; End;
//--------------------------------------------------------------------
Function EOI: Boolean; // End Of Single Item
Begin
   EOI:= TRUE;
   If Not EOS Then If AString[LinePos] <> ASeparator
      Then EOI:= FALSE
      Else EOI:= TRUE;
End;
//--------------------------------------------------------------------
Begin
   AStringList.Clear; StrgLen:= Length(AString); LinePos:= 1;
   While Not EOS Do Begin
      FirstPos:= LinePos;
      While (Not EOS) And (Not EOI) Do Inc(LinePos);
      ItemLen:= LinePos-FirstPos;
      If (ItemLen > 0) Or (ConsiderEmptyStrings) Then Begin
         SetLength(Interim,ItemLen);
         If ItemLen > 0 Then
            //Move(AString[FirstPos],Interim[1],ItemLen*2); // Version WideChar
            Move(AString[FirstPos],Interim[1],ItemLen); // Version AnsiChar
         AStringList.Add(Interim);
      End;
      Inc(LinePos); // = Skip separator
   End;
End;
//********************************************************************
Function FormatInt(AInteger: TInt32; ALength: TuInt8): TString8;
Var Interim: TString8; Index: TuInt8;
Begin
   Interim:= IntToStr(AInteger);
   Index:= Length(Interim)+1;
   While (Index > 4) Do Begin
      Dec(Index,3);
      Insert('.',Interim,Index);
   End;
   If AInteger >= 0
      Then Insert('+',Interim,1)
      Else Insert('-',Interim,1);
   While Length(Interim) < ALength Do Insert(' ',Interim,1);

   If Length(Interim) > ALength Then Begin
      SetLength(Interim,ALength);
      FillChar(Interim[1],ALength,'#');
   End;

   Result:= Interim;
End;
//********************************************************************
// Provides the file extension without the leading point
// (File extension is meant to have NO LEADING POINT)
// No exceptions expected
Function GetFileExt(AFileName: TString8): TString8;
Var FileExt: TString8;
Begin
   Result:= '';

   If Length(AFileName) > 0 Then Begin
      FileExt:= ExtractFileExt(AFileName);
      If (Length(FileExt) > 0) And (Copy(FileExt,1,1) = '.')
         Then Begin
            Delete(FileExt,1,1);
            FileExt:= UpperCase(FileExt);
            Result:= FileExt;
         End;
   End;
End;
//********************************************************************
Function GetFileNameWithoutExt(AFileName: TString8): TString8;
Const Point =  '.';
Var LocalName: TString8; PointPos: TuInt16;
Begin
   Result:= '';
   If Length(AFileName) > 0 Then Begin
      LocalName:= ExtractFileName(AFileName);
      PointPos:= Pos(Point,LocalName);
      If PointPos > 0
         Then SetLength(LocalName, PointPos-1);
      Result:= UpperCase(LocalName);
   End;
End;
//********************************************************************
Function GetImgDataSize(PixelFormat: TPixelFormat;
               WidthInPixels,HeightInPixels: TuInt16): TuInt32;
Var BytesPerPixel: TuInt8;
Begin
   Case PixelFormat Of
      pfLumen: BytesPerPixel:= 1;
      pfLumenWithAlpha: BytesPerPixel:= 2;
      pfRGB: BytesPerPixel:= 3;
      pfRGBA: BytesPerPixel:= 4;
      Else BytesPerPixel:= 0;
   End;
   RESULT:= BytesPerPixel*WidthInPixels*HeightInPixels;
End;
//********************************************************************
Function GetImgPixelSize
               (WidthInPixels,HeightInPixels: TuInt16): TuInt32;
Begin
   RESULT:= WidthInPixels*HeightInPixels;
End;
//********************************************************************
// No exceptions expected
Function IsPowerOf2(AValue: TuInt16): TBool8;
Var PowerOf2: TuInt32;
Begin
   Result:= FALSE;

   PowerOf2:= 1;
   While PowerOf2 < AValue Do Inc(PowerOf2,PowerOf2);

   If AValue = PowerOf2
      Then Result:= True;
End;
//********************************************************************
Function NextPowerOf2(AValue: TuInt16): TuInt32;
Var PowerOf2: TuInt32;
Begin
   PowerOf2:= 1;
   While PowerOf2 < AValue Do Inc(PowerOf2,PowerOf2);

   Result:= PowerOf2;
End;
//********************************************************************
Function ColorToCardinal(AColor: T32bColor): TuInt32;
Begin
   Result:= TuInt32(AColor);
End;
//********************************************************************
Function CardinalToColor(ACardinal: TuInt32): T32bColor;
Begin
   {With AColor Do Begin
      Red   :=  (ACardinal And $000000FF);
      Green := ((ACardinal And $0000FF00) Shr 8);
      Blue  := ((ACardinal And $00FF0000) Shr 16);
      Alpha := ((ACardinal And $FF000000) Shr 24);
   End; }
   Result:= T32bColor(ACardinal);
End;
//********************************************************************
// ColorCode: 'RRR/GGG/BBB/AAA', e.g. '000/096/255/255' = SPRUSSBLUE
Function GetColorByString(AColorString: ShortString): T32bColor;
Type TColorCode = AnsiString;
Var RStr,GStr,BStr,AStr: TColorCode;

Function CodeToByte(ACode: TColorCode): TuInt8;
Var TempInt: TInt32;
Begin
   Try
      TempInt:= StrToInt(ACode);
   Except
      On EConvertError Do TempInt:= 0;
   End;
   If TempInt > 255
      Then TempInt:= 255;

   Result:= TuInt8(TempInt);
End;

Begin
   RStr:= Copy(AColorString, 1,3);
   GStr:= Copy(AColorString, 5,3);
   BStr:= Copy(AColorString, 9,3);
   AStr:= Copy(AColorString, 13,3);

   With Result Do Begin
        Red:= CodeToByte(RStr);
      Green:= CodeToByte(GStr);
       Blue:= CodeToByte(BStr);
      Alpha:= CodeToByte(AStr);
   End;
End;
//********************************************************************
Function SetColorByGradient(AColor: T32bColor;
                       AGradient: TFloat32): T32bColor;
//---------------------------------------------------------
Function GradeDown(AColor: TuInt8): TuInt8;
Begin
   Result:= Trunc(AColor*(1+AGradient));
End;
//---------------------------------------------------------
Function GradeUp(AColor: TuInt8): TuInt8;
Begin
   Result:= Trunc(AColor*(1-AGradient) + AGradient*255);
End;
//---------------------------------------------------------
Begin
   If (AGradient >= 0) And (AGradient <= 1)
      Then With AColor Do Begin
         AGradient:= (AGradient - 0.5)*2;
         If AGradient < 0
            Then Begin // Range [-1..0]
               Result.Red  := GradeDown(Red);
               Result.Green:= GradeDown(Green);
               Result.Blue := GradeDown(Blue);
               Result.Alpha:= AColor.Alpha;
            End
            Else Begin // Range [0..+1]
               Result.Red  := GradeUp(Red);
               Result.Green:= GradeUp(Green);
               Result.Blue := GradeUp(Blue);
               Result.Alpha:= AColor.Alpha;
            End;
      End;
End;
//********************************************************************
// Quickfloat casts a string to a float and transforms a decimal point
// to a comma (german setting). It is necessary for formats that have
// the U.S. decimal point instead of a german decimal comma
Function QuickFloat(AString: String): TFloat32;
Var I: Byte;
Begin
   I:= Pos(',',AString);
   If I > 0
      Then AString[I]:= '.';
   Result:= StrToFloat(AString);
End;
//********************************************************************
// Checks if the given extension is included in "ValidExtensions"
// No exceptions expected
Function ValidFileExt(AFileName: TString8;
               ValidExtensions: TStdExtensions): TBool8;
Var CheckExt: TString8; I: TuInt16;
Begin
   Result:= FALSE;

   CheckExt:= GetFileExt(AFileName);
   For I:= 0 To High(ValidExtensions) Do
      If CheckExt = ValidExtensions[I]
         Then Result:= TRUE;
End;
//********************************************************************
// Checks if
// 1. the given filename is not empty
// 2. the given fiename refers to an existing file
// 3. the given extension is included in "ValidExtensions"
Function ValidFileName(AFileName: TString8;
                 ValidExtensions: TStdExtensions): TBool8;
Begin
   Result:= FALSE;

   If (Length(AFileName) > 0) And
      (ValidFileExt(AFileName,ValidExtensions))
      Then Result:= TRUE;
End;
//********************************************************************
//********************************************************************
End.

